com.google.cloud.dataflow.sdk.coders

## Class AtomicCoder<T>

- java.lang.Object
- - com.google.cloud.dataflow.sdk.coders.StandardCoder<T>
  - - com.google.cloud.dataflow.sdk.coders.DeterministicStandardCoder<T>
    - - com.google.cloud.dataflow.sdk.coders.AtomicCoder<T>

Type Parameters:
  `T` - the type of the values being transcoded

All Implemented Interfaces:
  Coder<T>, Serializable

Direct Known Subclasses:
  BigEndianIntegerCoder, BigEndianLongCoder, ByteArrayCoder, ByteCoder, ByteStringCoder, CustomCoder, DoubleCoder, DurationCoder, EntityCoder, GlobalWindow.Coder, InstantCoder, JAXBCoder, PaneInfo.PaneInfoCoder, Proto2Coder, ProtoCoder, SerializableCoder, StringUtf8Coder, TableRowJsonCoder, TextualIntegerCoder, VarIntCoder, VarLongCoder, VoidCoder

    public abstract class AtomicCoder<T>
    extends DeterministicStandardCoder<T>

A `Coder` that has no component `Coders` or other state.

Note that, unless the behavior is overridden, atomic coders are presumed to be deterministic and all instances are considered equal.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from interface com.google.cloud.dataflow.sdk.coders.Coder

`Coder.Context, Coder.NonDeterministicException`

### Constructor Summary

Constructors
`protected` `AtomicCoder()`

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`List<Coder<?>>` `getCoderArguments()` If this is a `Coder` for a parameterized type, returns the list of `Coder`s being used for each of the parameters, or returns `null` if this cannot be done or this is not a parameterized type.
`static <T> List<Object>` `getInstanceComponents(T exampleValue)` Returns a list of values contained in the provided example value, one per type parameter.

### Methods inherited from class com.google.cloud.dataflow.sdk.coders.DeterministicStandardCoder

`verifyDeterministic`

### Methods inherited from class com.google.cloud.dataflow.sdk.coders.StandardCoder

`asCloudObject, consistentWithEquals, equals, getAllowedEncodings, getComponents, getEncodedElementByteSize, getEncodingId, hashCode, isRegisterByteSizeObserverCheap, registerByteSizeObserver, structuralValue, toString, verifyDeterministic, verifyDeterministic`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface com.google.cloud.dataflow.sdk.coders.Coder

`decode, encode`

### Constructor Detail

#### AtomicCoder

    protected AtomicCoder()

### Method Detail

#### getCoderArguments

    public List<Coder<?>> getCoderArguments()

Description copied from interface: `Coder`
If this is a `Coder` for a parameterized type, returns the list of `Coder`s being used for each of the parameters, or returns `null` if this cannot be done or this is not a parameterized type.

#### getInstanceComponents

    public static <T> List<Object> getInstanceComponents(T exampleValue)

Returns a list of values contained in the provided example value, one per type parameter. If there are no type parameters, returns an empty list.

Because `AtomicCoder` has no components, always returns an empty list.

Parameters:
  `exampleValue` - unused, but part of the latent interface expected by `CoderFactories.fromStaticMethods(java.lang.Class<T>)`